/*
** method.c for rhttpr in ~rflav/works/rhttpr on nightmare
** 
** Made by rflav
** Login   <flav@epita.fr>
** 
** Started on  Mon Jan 10 17:29:57 2000 rflav
** Last update Tue Feb 22 18:07:30 2000 rflav
*/
#include <gen.h>

int		rhttpr_numdigit(num)
int		num;
{
  int		n;

  n = 1;
  while ((num /= 10) != 0)
    n++;
  return (n);
}

int		rhttpr_size_method(rq,method)
t_httprq	*rq;
char		*method;
{
  int		size;

  size = strlen(method) + strlen(DEF_EVERSION) + strlen(DEF_EAGENT) +
    strlen(DEF_EHOST) + strlen(DEF_EACCEPT) + strlen(DEF_ECHARSET) +
    strlen(rq->user_agent) + strlen(rq->host) + rhttpr_numdigit(rq->port) +
    strlen(DEF_ECONTENTL) + rhttpr_numdigit(rq->data_len) + 64;
  if (rq->data)
    size += rq->data_len + 2;
  if (rq->action)
    size += strlen(rq->action) + 2;
  if (rq->referer)
    size += strlen(rq->referer) + strlen(DEF_EREFERER) + 2;
  if (rq->proxy_user)
    size += strlen(rq->auth_string) + 2;
  if (rq->cookie)
    size += strlen(rq->cookie) + strlen(DEF_ECOOKIE) + 2;
  if (rq->contentype)
    size += strlen(rq->contentype) + strlen(DEF_ECONTENTY) + 2;
  return (size);
}

void		rhttpr_mk_get_rq(sd,rq)
int		sd;
t_httprq	*rq;
{
  char		*buf;
  int		size;

  size = rhttpr_size_method(rq,DEF_EGET);
  F_MALLOC(buf,size,"tmp buf");
  memset(buf,0,size);
  if (rq->action)
    sprintf(buf,"%s http://%s:%d%s?%s",DEF_EGET,rq->host,rq->port,
	     rq->action,rq->data);
  else
    sprintf(buf,"%s http://%s:%d%s",DEF_EGET,rq->host,rq->port,rq->data);
  sprintf(buf,"%s %s\n%s %s\n%s %s:%d\n%s\n%s\n",
	   buf,DEF_EVERSION,DEF_EAGENT,rq->user_agent,
	   DEF_EHOST,rq->host,rq->port,DEF_EACCEPT,DEF_ECHARSET);
  if (rq->contentype)
    sprintf(buf,"%s%s %s\r\n",buf,DEF_ECONTENTY,rq->contentype);
  if (rq->proxy_user)
    sprintf(buf,"%s%s",buf,rq->auth_string);
  if (rq->cookie)
    sprintf(buf,"%s%s %s\n",buf,DEF_ECOOKIE,rq->cookie);
  if (rq->referer)
    sprintf(buf,"%s%s %s\r\n\r\n",buf,DEF_EREFERER,rq->referer);
  else
    sprintf(buf,"%s\r\n\r\n",buf);
  rhttpr_sdwrite(sd,buf,strlen(buf));
  free(buf);
}

void		rhttpr_mk_post_rq(sd,rq)
int		sd;
t_httprq	*rq;
{
  char		*buf;
  int		size;

  size = rhttpr_size_method(rq,DEF_EPOST);
  F_MALLOC(buf,size,"tmp buf post method");
  if (rq->action)
    sprintf(buf,"%s http://%s:%d%s",DEF_EPOST,rq->host,rq->port,
             rq->action);
  else
    sprintf(buf,"%s http://%s:%d",DEF_EPOST,rq->host,rq->port);
  sprintf(buf,
	   "%s %s\r\n%s %s\r\n%s %s:%d\r\n%s\r\n%s\r\n%s %d\r\n",
	   buf,DEF_EVERSION,DEF_EAGENT,rq->user_agent,DEF_EHOST,rq->host,
	   rq->port,DEF_EACCEPT,DEF_ECHARSET,DEF_ECONTENTL,rq->data_len);
  if (rq->contentype)
    sprintf(buf,"%s%s %s\r\n",buf,DEF_ECONTENTY,rq->contentype);
  if (rq->proxy_user)
    sprintf(buf,"%s%s",buf,rq->auth_string);
  if (rq->cookie)
    sprintf(buf,"%s%s %s\r\n",buf,DEF_ECOOKIE,rq->cookie);
  if (rq->referer)
    sprintf(buf,"%s%s %s\r\n\r\n",buf,DEF_EREFERER,rq->referer);
  else
    sprintf(buf,"%s\r\n\r\n",buf);
  sprintf(buf,"%s%s\r\n\r\n",buf,rq->data);
  rhttpr_sdwrite(sd,buf,strlen(buf));
  free(buf);
}

void		rhttpr_mk_head_rq(sd,rq)
int		sd;
t_httprq	*rq;
{
  char		*buf;
  int		size;

  size = rhttpr_size_method(rq,DEF_EHEAD);
  F_MALLOC(buf,size,"tmp buf");
  memset(buf,0,size);
  if (rq->action)
    sprintf(buf,"%s http://%s:%d%s?%s",DEF_EHEAD,rq->host,rq->port,
	     rq->action,rq->data);
  else
    sprintf(buf,"%s http://%s:%d%s",DEF_EHEAD,rq->host,rq->port,
	     rq->data);
  sprintf(buf,"%s %s\n%s %s\n%s %s:%d\n%s\n%s\n",
	   buf,DEF_EVERSION,DEF_EAGENT,rq->user_agent,
	   DEF_EHOST,rq->host,rq->port,DEF_EACCEPT,DEF_ECHARSET);
  if (rq->contentype)
    sprintf(buf,"%s%s %s\r\n",buf,DEF_ECONTENTY,rq->contentype);
  if (rq->proxy_user)
    sprintf(buf,"%s%s",buf,rq->auth_string);
  if (rq->cookie)
    sprintf(buf,"%s%s %s\n",buf,DEF_ECOOKIE,rq->cookie);
  if (rq->referer)
    sprintf(buf,"%s%s %s\r\n\r\n",buf,DEF_EREFERER,rq->referer);
  else
    sprintf(buf,"%s\r\n\r\n",buf);
  rhttpr_sdwrite(sd,buf,strlen(buf));
  free(buf);
}
