/*
** set_proxy_auth.c for rhttpr in ~rflav/works/c/rhttpr on nightmare
** 
** Made by rflav
** Login   <flav@epita.fr>
** 
** Started on  Fri Feb  4 18:42:21 2000 rflav
** Last update Tue Feb 22 11:06:54 2000 rflav
*/
#include <gen.h>

void		rhttpr_base64_encode(s,store,length)
char		*s;
char		*store;
int		length;
{
  char	tbl[64] = 
  {
    'A','B','C','D','E','F','G','H',
    'I','J','K','L','M','N','O','P',
    'Q','R','S','T','U','V','W','X',
    'Y','Z','a','b','c','d','e','f',
    'g','h','i','j','k','l','m','n',
    'o','p','q','r','s','t','u','v',
    'w','x','y','z','0','1','2','3',
    '4','5','6','7','8','9','+','/'
  };
  int		i;
  unsigned char	*p;

  p = (unsigned char *)store;
  for (i = 0; i < length; i += 3)
    {
      *p++ = tbl[s[0] >> 2];
      *p++ = tbl[((s[0] & 3) << 4) + (s[1] >> 4)];
      *p++ = tbl[((s[1] & 0xf) << 2) + (s[2] >> 6)];
      *p++ = tbl[s[2] & 0x3f];
      s += 3;
    }
  if (i == length + 1)
    *(p - 1) = '=';
  else 
    if (i == length + 2)
      *(p - 1) = *(p - 2) = '=';
  *p = '\0';
}

char	*rhttpr_basic_authentication(user,passwd,header)
char	*user;
char	*passwd;
char	*header;
{
  char	*t1;
  char	*t2;
  char	*res;
  int	len1;
  int	len2;
  
  len1 = strlen(user) + 1 + strlen(passwd);
  len2 = BASE64_LENGTH(len1);
  F_MALLOC(t1,len1+1,"");
  sprintf(t1,"%s:%s",user,passwd);
  F_MALLOC(t2,len2+1,"");
  rhttpr_base64_encode(t1,t2,len1);
  F_MALLOC(res,len2 + 11 + strlen(header),"");
  sprintf(res,"%s Basic %s\r\n",header,t2);
  free(t1);
  free(t2);
  return (res);
}

void		rhttpr_set_proxy_auth(rq)
t_httprq	*rq;
{
  if (!rq->proxy_passwd)
    return;
  rq->auth_string = rhttpr_basic_authentication(rq->proxy_user,
						rq->proxy_passwd,
						R_AUTH);
}
